//correct solution

#include <iostream>
#include <algorithm>

using namespace std;

const int maxn = 200000;

int n, a[maxn];
int b[maxn], c[maxn];

int dist(int i, int j)
{
   return min(abs((i-j+n)%n), abs((j-i+n)%n));
}

int solve()
{
   int best = -1, i, k;
   for (i = 1; i <= n/2; i++) {
      best = max(best, a[i]+i);
      b[i] = best;
   }
   int ans = 0;
   for (k = 0; k < n; k++) {
      int t = k+n/2;
      ans = max(ans, b[t%n] - k + a[k]);
      b[(t+1)%n] = max(b[t%n], a[(t+1)%n]+t+1);
   }
   return ans;
}

int main()
{
   freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
   
   int i, j = 0;
   cin >> n;
   for (i = 0; i < n; i++) {
      cin >> a[i];
      if (a[i] > a[j]) j = i;
   }
   
   int ans = 0;
   for (i = 0; i < n; i++)
      if (i != j) ans = max(ans, dist(i, j) + a[i]);
   
   if (ans <= a[j]) {
      ans += a[j];
   } else {
      ans = solve();
      for (i = 0; i < (n+1)/2; i++) swap(a[i], a[n-i-1]);
      int ans1 = solve();
      ans = max(ans, ans1);
   }
   cout << ans << endl;

   fclose(stdin); fclose(stdout);
   return 0;
}